<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierPerson_V2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierPerson_V2 extends AbstractStructArrayBase
{
    /**
     * The IdentifierPerson_V2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierPerson_V2[]
     */
    public $IdentifierPerson_V2;
    /**
     * Constructor method for ArrayOfIdentifierPerson_V2
     * @uses ArrayOfIdentifierPerson_V2::setIdentifierPerson_V2()
     * @param \StructType\IdentifierPerson_V2[] $identifierPerson_V2
     */
    public function __construct(array $identifierPerson_V2 = array())
    {
        $this
            ->setIdentifierPerson_V2($identifierPerson_V2);
    }
    /**
     * Get IdentifierPerson_V2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierPerson_V2[]|null
     */
    public function getIdentifierPerson_V2()
    {
        return isset($this->IdentifierPerson_V2) ? $this->IdentifierPerson_V2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setIdentifierPerson_V2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIdentifierPerson_V2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIdentifierPerson_V2ForArrayConstraintsFromSetIdentifierPerson_V2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfIdentifierPerson_V2IdentifierPerson_V2Item) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierPerson_V2IdentifierPerson_V2Item instanceof \StructType\IdentifierPerson_V2) {
                $invalidValues[] = is_object($arrayOfIdentifierPerson_V2IdentifierPerson_V2Item) ? get_class($arrayOfIdentifierPerson_V2IdentifierPerson_V2Item) : sprintf('%s(%s)', gettype($arrayOfIdentifierPerson_V2IdentifierPerson_V2Item), var_export($arrayOfIdentifierPerson_V2IdentifierPerson_V2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IdentifierPerson_V2 property can only contain items of type \StructType\IdentifierPerson_V2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set IdentifierPerson_V2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierPerson_V2[] $identifierPerson_V2
     * @return \ArrayType\ArrayOfIdentifierPerson_V2
     */
    public function setIdentifierPerson_V2(array $identifierPerson_V2 = array())
    {
        // validation for constraint: array
        if ('' !== ($identifierPerson_V2ArrayErrorMessage = self::validateIdentifierPerson_V2ForArrayConstraintsFromSetIdentifierPerson_V2($identifierPerson_V2))) {
            throw new \InvalidArgumentException($identifierPerson_V2ArrayErrorMessage, __LINE__);
        }
        if (is_null($identifierPerson_V2) || (is_array($identifierPerson_V2) && empty($identifierPerson_V2))) {
            unset($this->IdentifierPerson_V2);
        } else {
            $this->IdentifierPerson_V2 = $identifierPerson_V2;
        }
        return $this;
    }
    /**
     * Add item to IdentifierPerson_V2 value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierPerson_V2 $item
     * @return \ArrayType\ArrayOfIdentifierPerson_V2
     */
    public function addToIdentifierPerson_V2(\StructType\IdentifierPerson_V2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierPerson_V2) {
            throw new \InvalidArgumentException(sprintf('The IdentifierPerson_V2 property can only contain items of type \StructType\IdentifierPerson_V2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IdentifierPerson_V2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierPerson_V2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierPerson_V2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierPerson_V2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierPerson_V2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierPerson_V2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierPerson_V2
     */
    public function getAttributeName()
    {
        return 'IdentifierPerson_V2';
    }
}
